<template>
  <tr>
    <appTableTd>{{ name }} </appTableTd>
    <appTableTd>{{ checkIn }} </appTableTd>
    <appTableTd>{{ checkOut }} </appTableTd>
    <appTableTd>{{ breakTime }} </appTableTd>
    <appTableTd>{{ breakWorked }} </appTableTd>
    <appTableTd>{{ position }} </appTableTd>
    <appTableTd>{{ location }} </appTableTd>
  </tr>
</template>

<script>
import apiMixin from '../../mixins/api';
export default {
  name: 'turnCard',
  mixins: [apiMixin],
  props: {
    turnTemplate: {
      type: Object,
      default: () => ({}),
    },
  },
  computed: {
    name() {
      return this.turnTemplate.name;
    },
    checkIn() {
      return this.turnTemplate.checkIn;
    },
    checkOut() {
      return this.turnTemplate.checkOut;
    },
    breakTime() {
      return this.turnTemplate.breakTime;
    },
    breakWorked() {
      const start = this.checkIn
        .split(':')
        .reduce((p, c) => parseInt(p) * 60 + parseInt(c));
      const end = this.checkOut
        .split(':')
        .reduce((p, c) => parseInt(p) * 60 + parseInt(c));

      return Math.floor((end - start) / 60);
    },
    position() {
      const positionId = this.turnTemplate.positionId;
      const { name } =
        this.positionList.find(({ id }) => positionId === id) || {};
      return name || 'Desconocido';
    },
    location() {
      const locationId = this.turnTemplate.locationId || [];
      const locationsNames = this.locationList
        .filter(({ id }) => !!locationId.find((entry) => id === entry))
        .map(({ name }) => name);
      return locationsNames.join(', ').trim() || 'Desconocido';
    },
  },
  methods: {},
};
</script>

<style></style>
